
;//---------------------------------------------------------
;// FASM 1.73.31 -     API NtAlpc_xxxx
;// @Marylin  13.03.2025. https://codeby.net/forums/assembler-assembler.229/
;//---------------------------------------------------------

INFINITY = -1

;//   NTSTATUS
;//-----------------------------------------
STATUS_SUCCESS                       = 0           ;   
STATUS_INVALID_HANDLE                = 0xC0000008  ;  
STATUS_INVALID_PARAMETERS            = 0xC000000d  ;  
STATUS_ACCESS_DENIED                 = 0xC0000022  ;  
STATUS_BUFFER_TOO_SMALL              = 0xC0000023  ;   
STATUS_OBJECT_NAME_NOT_FOUND         = 0xC0000034  ;    
STATUS_OBJECT_PATH_NOT_FOUND         = 0xc000003a  ;     
STATUS_OBJECT_PATH_SYNTAX_BAD        = 0xC000003b  ;   
STATUS_PORT_CONNECTION_REFUSED       = 0xC0000041  ;    
STATUS_INVALID_PARAMETERS_1          = 0xC00000ef  ;    ......
STATUS_INVALID_PARAMETERS_2_12       = 0xC00000f0  ;-fa    ......  
STATUS_TIMEOUT                       = 0x00000102  ;  
STATUS_REPLY_MESSAGE_MISMATCH        = 0xC000021f  ;   
STATUS_LPC_REPLY_LOST                = 0xC0000253  ;  
STATUS_SERVER_SID_MISMATCH           = 0xC00002a0  ;  sid 
STATUS_LPC_RECEIVE_BUFFER_EXPECTED   = 0xC0000705  ;   
STATUS_LPC_INVALID_CONNECTION_USAGE  = 0xC0000706  ;   
STATUS_LPC_REQUESTS_NOT_ALLOWED      = 0xC0000707  ;   
STATUS_LPC_HANDLE_COUNT_EXCEEDED     = 0xC0000722  ;  - 

;// NtAlpcCreatePort()
;// Flags   ALPC_PORT_ATTRIBUTES
;//-------------------------------------------
ALPC_PORTFLG_NONE                =  0
ALPC_PORTFLG_ALL                 =  0x01ef0000
ALPC_PORTFLG_ALLOWIMPERSONATION  =  0x00010000   ;       
ALPC_PORTFLG_ALLOW_LPC_REQUESTS  =  0x00020000   ;     ( = ALPC_PORTFLG_NONE)
ALPC_PORTFLG_WAITABLE_PORT       =  0x00040000   ;    (, ,  )
ALPC_PORTFLG_ALLOW_DUP_OBJECT    =  0x00080000   ;    
ALPC_PORTFLG_LRPC_WAKE_POLICY1   =  0x00200000   ; Win10+
ALPC_PORTFLG_LRPC_WAKE_POLICY2   =  0x00400000   ;  ^^^^
ALPC_PORTFLG_LRPC_WAKE_POLICY3   =  0x00800000   ;    ^^^^
ALPC_PORTFLG_DIRECT_MESSAGE      =  0x01000000   ;      ^^^^ 
                                                 ;  5 : , , , , .
                                                 ;  Direct   ,  .
align 8
struct ALPC_PORT_ATTRIBUTES  ;<------ 10 elements, 0x48 bytes
   Flags                 dd  0
   SecurityQos           dd  0,0,0   ; SECURITY_QUALITY_OF_SERVICE
   MaxMessageLength      dq  0
   MemoryBandwidth       dq  0
   MaxPoolUsage          dq  0
   MaxSectionSize        dq  0
   MaxViewSize           dq  0
   MaxTotalSectionSize   dq  0
   DupObjectTypes        dd  0
   Reserved              dd  0
ends
align 8
struct OBJECT_ATTRIBUTES     ;<------ 6 elements, 0x30 bytes
   Length                dq  sizeof.OBJECT_ATTRIBUTES
   RootDirectory         dq  0    ; 
   ObjectName            dq  0    ; UNICODE_STRING
   Attributes            dq  0    ; OBJ_EXCLUSIVE(0x20) =   (    )
   SecurityDesc          dq  0    ; . SECURITY_DESCRIPTOR  MSDN
   SecurityOfService     dq  0
ends

;// Flags  NtAlpcSendWaitReceivePort()
;//---------------------------------------
ALPC_MSGFLG_NONE             =  0             ;   ()
ALPC_MSGFLG_REPLY_MESSAGE    =  1             ;              
ALPC_MSGFLG_LPC_MODE         =  2             ;  lpc
ALPC_MSGFLG_RELEASE_MESSAGE  =  0x00010000    ;  
ALPC_MSGFLG_SYNC_REQUEST     =  0x00020000    ;  
ALPC_MSGFLG_WAIT_USER_MODE   =  0x00100000    ;   
ALPC_MSGFLG_WAIT_ALERTABLE   =  0x00200000    ;  
ALPC_MSGFLG_WOW64_CALL       =  0x80000000    ;  wow64

;// Flags  NtAlpcAcceptConnectPort()
;//-------------------------------------
ALPC_SYNC_CONNECTION    =  0x020000   ;     LPC (  ALPC)
ALPC_USER_WAIT_MODE     =  0x100000   ;    
ALPC_WAIT_IS_ALERTABLE  =  0x200000   ;    


;//*******************************************************************************

struct ALPC_SECURITY_ATTR
   Flags             dd  0
   pQOS              dd  0,0,0   ; QualityOfService
   ContextHandle     dq  0
ends
struct ALPC_DATA_VIEW_ATTR
   Flags             dq  0
   SectionHandle     dq  0
   ViewBase          dq  0
   ViewSize          dq  0
ends
struct ALPC_CONTEXT_ATTR
   PortContext       dq  0
   MessageContext    dq  0
   Sequence          dd  0
   MessageId         dd  0
   CallbackId        dd  0
   Padding           dd  0
ends
struct ALPC_HANDLE_ATTR
   Handle            dq  0
ends
struct ALPC_TOKEN_ATTR
   TokenId           dq  0
   AuthenticationId  dq  0
   ModifiedId        dq  0
   Padding           dq  0
ends
struct ALPC_DIRECT_ATTR
   Event             dq  0
ends
struct ALPC_WORK_ON_BEHALF_ATTR
   Ticket            dq  0
ends

;//  "Attributes"  NtAlpcSendWaitReceivePort()
;//------------------------------------------------------
struct ALPC_MESSAGE_ATTRIBUTES
   AllocatedAttributes  dd  0    ;// 
   ValidAttributes      dd  0    ;//    ALPC_MESSAGE_xx
   Security             ALPC_SECURITY_ATTR
   View                 ALPC_DATA_VIEW_ATTR
   Context              ALPC_CONTEXT_ATTR        ;<---  Valid
   Handle               ALPC_HANDLE_ATTR
   Token                ALPC_TOKEN_ATTR          ;<---  Valid
   Direct               ALPC_DIRECT_ATTR
   WorkOnBehalf         ALPC_WORK_ON_BEHALF_ATTR
   Padding              dq  0
ends

;//    ALPC_MESSAGE_ATTR
;//-------------------------------------------------
ALPC_MESSAGE_SECURITY_ATTRIBUTE        =  0x80000000 
ALPC_MESSAGE_VIEW_ATTRIBUTE            =  0x40000000 
ALPC_MESSAGE_CONTEXT_ATTRIBUTE         =  0x20000000
ALPC_MESSAGE_HANDLE_ATTRIBUTE          =  0x10000000
ALPC_MESSAGE_TOKEN_ATTRIBUTE           =  0x08000000 
ALPC_MESSAGE_DIRECT_ATTRIBUTE          =  0x04000000 
ALPC_MESSAGE_WORK_ON_BEHALF_ATTRIBUTE  =  0x02000000 
ALPC_MESSAGE_ATTRIBUTE_ALL             =  0xFE000000

;//************************************************************

align 8
struct UNICODE_STRING     ;<---- 3 elements, 0x10 bytes
   Length             dw  0
   MaximumLength      dw  0
   Padding            dd  0
   Buffer             dq  0
ends
align 8
struct PORT_MESSAGE       ;<---- 7 elements, 0x28 bytes
   u1.DataLength      dw  0
   u1.TotalLength     dw  0
   u2.Type            dw  0
   u2.DataInfoOffset  dw  0
   ClientPid          dq  0       ; CLIENT_ID
   ClientTid          dq  0
   MessageId          dq  0
   CallbackId         dq  0       ; or ClientViewSize
ends

;// MessageType   PORT_MESSAGE -> u2.Type
;//-------------------------------------------
LPC_REQUEST             =  1
LPC_REPLY               =  2
LPC_DATAGRAM            =  3
LPC_LOST_REPLY          =  4
LPC_PORT_CLOSED         =  5
LPC_CLIENT_DIED         =  6
LPC_EXCEPTION           =  7
LPC_DEBUG_EVENT         =  8
LPC_ERROR_EVENT         =  9
LPC_CONNECTION_REQUEST  =  10
LPC_CONNECTION_REPLY    =  11
LPC_INTERNAL_REQUEST    =  12   ; Pid\Tid = 0
LPC_PORT_DISCONNECTED   =  13

align 8
struct ALPC_BASIC_INFORMATION     ;  AlpcBasicInfo
   Flags          dd  0
   SequenceNo     dd  0
   PortContext    dq  0
ends












